// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlCenteringBin")]
    pub struct CenteringBin(Object<ffi::DzlCenteringBin, ffi::DzlCenteringBinClass>) @extends gtk::Bin, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_centering_bin_get_type(),
    }
}

impl CenteringBin {
    pub const NONE: Option<&'static CenteringBin> = None;

    #[doc(alias = "dzl_centering_bin_new")]
    pub fn new() -> CenteringBin {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_centering_bin_new()).unsafe_cast() }
    }
}

impl Default for CenteringBin {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::CenteringBin>> Sealed for T {}
}

pub trait CenteringBinExt: IsA<CenteringBin> + sealed::Sealed + 'static {
    #[doc(alias = "max-width-request")]
    fn max_width_request(&self) -> i32 {
        ObjectExt::property(self.as_ref(), "max-width-request")
    }

    #[doc(alias = "max-width-request")]
    fn set_max_width_request(&self, max_width_request: i32) {
        ObjectExt::set_property(self.as_ref(), "max-width-request", max_width_request)
    }

    #[doc(alias = "max-width-request")]
    fn connect_max_width_request_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_max_width_request_trampoline<
            P: IsA<CenteringBin>,
            F: Fn(&P) + 'static,
        >(
            this: *mut ffi::DzlCenteringBin,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(CenteringBin::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::max-width-request\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_max_width_request_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<CenteringBin>> CenteringBinExt for O {}

impl fmt::Display for CenteringBin {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("CenteringBin")
    }
}
